import router, {
  asyncRoutes,
  allRouters
} from './router'
import store from './store'
import {
  Message
} from 'element-ui'
import NProgress from 'nprogress' // progress bar
import 'nprogress/nprogress.css' // progress bar style
import {
  getToken
} from '@/utils/auth' // get token from cookie
import getPageTitle from '@/utils/get-page-title'
import Layout from '@/layout'
import {
  console
} from 'vuedraggable/src/util/helper'

NProgress.configure({
  showSpinner: false
}) // NProgress Configuration

const whiteList = ['/login', '/auth-redirect'] // no redirect whitelist
router.beforeEach(async (to, from, next) => {
  // start progress bar
  NProgress.start()

  // set page title
  document.title = getPageTitle(to.meta.title)

  // determine whether the user has logged in
  const hasToken = getToken()

  if (hasToken) {
    if (to.path === '/login') {
      // if is logged in, redirect to the home page
      next({
        path: '/'
      })
      NProgress.done() // hack: https://github.com/PanJiaChen/vue-element-admin/pull/2939
    } else {
      // determine whether the user has obtained his permission roles through getInfo
      const hasRoles = store.getters.permission_routes && store.getters.permission_routes.length > 0
      if (!hasRoles) {
        try {

          // const { roles=['admin'] } = await store.dispatch('user/getInfo')
          // store.commit('SET_ROUTES', asyncRoutes)

          // next({ ...to, replace: true })
          // get user info
          // note: roles must be a object array! such as: ['admin'] or ,['developer','editor']

          // this.$store.commit('SET_ROLES', ['admin'])
          // this.$store.commit('SET_NAME', '小明')
          // this.$store.commit('SET_AVATAR', 'https://wpimg.wallstcn.com/f778738c-e4f8-4870-b634-56703b4acafe.gif')
          // this.$store.commit('SET_INTRODUCTION', )

          // generate accessible routes map based on roles
          //   const accessRoutes = await store.dispatch('permission/generateRoutes', ['admin'])
          //
          //var routers = [] // 这个参数是我自己写死的路由数组
          let accessRoutes = await store.dispatch('permission/generateRoutes', []) // routers没什么用，他返回的参数再generateRoutes
          router.addRoutes(accessRoutes)
          // next()
          //
          // // hack method to ensure that addRoutes is complete
          // // set the replace: true, so the navigation will not leave a history record
          console.log(router, to, 2222222)
          next({
            ...to,
            replace: true
          })
        } catch (error) {
          // remove token and go to login page to re-login
          // await store.dispatch('user/resetToken')
          Message.error({
            message: error || 'Has Error'
          })
          next(`/login?redirect=${to.path}`)
          //   console.log(router,to,44444);
          //   next()
          NProgress.done()
        }
      } else {
        console.log(router, to, 5555)
        next()
      }
    }
  } else {
    /* has no token*/
    console.log(router, to, 11111)
    if (whiteList.indexOf(to.path) !== -1) {
      // in the free login whitelist, go directly
      next()
    } else {
      console.log(router, to, 33333)
      // other pages that do not have permission to access are redirected to the login page.
      next(`/login?redirect=${to.path}`)
      NProgress.done()
    }
  }
})

router.afterEach(() => {
  // finish progress bar
  NProgress.done()
})
